function [a,b] = betain(mean,var)

if var < 0
    error('fatal (betain) negative variance')
end

if mean < 0 | mean > 1
    error('fatal (betain) mean outside unit interval')
end


a=mean*(mean*(1-mean)/var-1);
b=(1-mean)*a/mean;

