if docheck_XXX ==1
    
    xx   =   map(xx);
    undo
    
    [alphas,alpha_2,alpha_1,alpha_0,betas] = newalphabeta(size_a,size_b,sigmaa,xiw,xip,Sdoupr,Hdoupr,rhotil,aptil,aytil,amtil,actil,iota1,iota2,iotaw1,iotaw2,iotamu,adptil,adytil,xiE,par1,par2,par3,par4,par5,par6,par7,par8,par9,par10);
                                                                      
    [A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);

    l_z=length(A);
    
    [B,B1,B2,P,rrho,betas] = findandcheckB(A,alphas,rho,taushock,taumat,betas);
    
    [alf_0,taum_0,taub_0,taus_0,tausb_0] = linear1(tau,her,ksi,Rb,Re,c,y,i,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pi,g, ...
        ev,Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,M,m1,upsil,currdep,Ra,dm,m3,l_z,demean,mm,taushock,parstoch,A, ...
        B1,B2,duration1,rho,beta,tauvar,gamma,alpha,R,ttt2,entr,tauc,duration2,taud,params);
    
    disp(' (check_taus) comparing the taus and alf from analytic formulas with corresponding objects obtained numerically')
    
    index=find(zz==1); %equations to be checked
    indx1 = find(index==12);
    if isempty(indx1) ==0
        index = index([[1:indx1-1] [indx1+1:length(index)]]);
    end
    if entr==2 || entr==-4
        indx1 = find(index==14);
        if isempty(indx1) ==0
           index = index([[1:indx1-1] [indx1+1:length(index)]]);
        end
    end
    
    h=l;
    
    entr2=0;
    entr4=0;
    if entr==2; entr=1; entr2=1; end
    if entr==-4; entr=-3; entr4=1; end
    loadupnonlinnew
    if entr2==1; entr=2; end
    if entr4==1; entr=-4; end
    
    z0 = z0(1:end-5);
    zm1 = zm1(1:end-5);
    pp=[z0'; zm1'; psip0'];

    [ff] = checkX(pp,params,pi,fdiff,entr);
    if demean==0
        if fdiff ==0
            ff(1)=0; %we don't try to match the mean of n/y
            ff(6)=0; %we don't try to match the mean of w/y
        elseif fdiff ==1
            ff(1) = log(ff(1));
            ff(6) = log(ff(6));
        end

        ff(2) = log(ff(2));
        ff(3)=0; %we don't try to match the mean of l
        ff(5)=log(ff(5));
        ff(7)=log(ff(7));
        ff(8)=log(ff(8));
        ff(9)=log(ff(9));
        ff(10)=log(ff(10));

        ff_check=[index', ff(index)-alf_0(index)];
        if max(abs(ff_check(:,2))) > .2e-7
            disp('rows of alf which did not pass the check')
            ff_check
            error('fatal (check_taus) accuracy check on alf failed')
        end
    end

    %get the numerical derivatives:
    [QQ]=derivative('checkX',pp,params,pi,fdiff,entr);

    %convert the numerical derivatives to 'hats'...
    for ii = 1:length(pp)
        QQ(:,ii)=QQ(:,ii)*pp(ii);
    end
    
    if fdiff ==0

        if entr ==-2 || entr ==-1 || entr==0 
            if do_qavrg ==0
                ax=QQ(1,8);
            elseif do_qavrg ==1
                ax=QQ(1,31);
            end
        end
        QQ(1,:)=QQ(1,:)/ax;

        ax=QQ(6,19);
        QQ(6,:)=QQ(6,:)/ax;

        ax=QQ(7,4);
        QQ(7,:)=QQ(7,:)/ax;
        ax=taum_0(7,4);
        taum_0(7,:)=taum_0(7,:)/ax; %Note that we do this normalisation for checking reasons only
        taub_0(7,:)=taub_0(7,:)/ax;
        taus_0(7,:)=taus_0(7,:)/ax;

        ax=QQ(8,4);
        QQ(8,:)=QQ(8,:)/ax;
        ax=taum_0(8,4);
        taum_0(8,:)=taum_0(8,:)/ax; %Note that we do this normalisation for checking reasons only
        taub_0(8,:)=taub_0(8,:)/ax;
        taus_0(8,:)=taus_0(8,:)/ax;

        ax=QQ(9,4);
        QQ(9,:)=QQ(9,:)/ax;
        ax=taum_0(9,4);
        taum_0(9,:)=taum_0(9,:)/ax; %Note that we do this normalisation for checking reasons only
        taub_0(9,:)=taub_0(9,:)/ax;
        taus_0(9,:)=taus_0(9,:)/ax;

        ax=QQ(10,4);
        QQ(10,:)=QQ(10,:)/ax;
        ax=taum_0(10,4);
        taum_0(10,:)=taum_0(10,:)/ax; %Note that we do this normalisation for checking reasons only
        taub_0(10,:)=taub_0(10,:)/ax;
        taus_0(10,:)=taus_0(10,:)/ax;

    elseif fdiff ==1
        QQ(1,:) = QQ(1,:)/muzstar;
        QQ(4,:) = QQ(4,:)/muzstar;
        QQ(6,:) = QQ(6,:)/muzstar;
        QQ(7,:) = QQ(7,:)/(muzstar*upsil);
        QQ(8,:) = QQ(8,:)/muzstar;
        QQ(9,:) = QQ(9,:)/muzstar;
        QQ(10,:) = QQ(10,:)/muzstar;
    end

    QQ(2,:) = QQ(2,:)/pi;
    
    QQ(3,:) = QQ(3,:)/l;
    
    ax=QQ(5,length(z0)*2+31); %normalised on muz(t)
    QQ(5,:)=QQ(5,:)/ax;
     
    QQ(16,:) = QQ(16,:)/muzstar;
    
    QQ(17,:) = QQ(17,:)*upsil;
    
    QQ(20,:) = QQ(20,:)/muzstar;
    
    %load QQ into the tau's
    taum_1   = QQ(:,1:size(A,1));
    taub_1   = QQ(:,size(A,1)+1:2*size(A,1));
    taus_1   = QQ(:,2*size(A,1)+1:end);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
    b1j=[];
    beta1=[];
    for ii=1:size(taum_1,1)
        for j=1:length(taushock) %number of shocks
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(1) = 1;
            if taushock(j) ==3
                taux = taux*M(3,3); %note:we have multiplied the entry that selects psil(t) by (1-psil) as this shock lies in the unit interval and we have adjusted betas in makealphabeta and tauus in linear accordingly through the matrix M
            elseif taushock(j) ==4
                taux = taux*M(4,4);
            elseif taushock(j) == 5
                taux = taux*M(5,5);
            end
            bb1_1 = taus_1(ii,2*(taushock(j)-1)+1)*taux;
            
            taux(1) =0;
            taux(2) =1;
            if taushock(j) ==3
                taux = taux*M(3,3);
            elseif taushock(j) ==4
                taux = taux*M(4,4);
            elseif taushock(j) == 5
                taux = taux*M(5,5);
            end
            bb1_2 = taus_1(ii,2*(taushock(j)-1)+2)*taux;
            
            bb1 = bb1_1 + bb1_2;
            b1j =[b1j, bb1];
        end
        beta1 = [beta1; b1j];
        b1j=[];
    end
    taus_1 = beta1;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    ix0=0;
    ix1=0;
    ixs0=0;
    ixs1=0;
    tol=.1e-4;
    for ii = 1:length(index)
        for jj = 1:l_z
            if abs(taum_0(index(ii),jj)-taum_1(index(ii),jj)) > tol
                ix0=ix0+1;
                II0(ix0,1)=index(ii);
                II0(ix0,2)=jj;
            end
            if abs(taub_0(index(ii),jj)-taub_1(index(ii),jj)) > tol
                ix1=ix1+1;
                II1(ix1,1)=index(ii);
                II1(ix1,2)=jj;
            end
        end
        for jj = 1:size(taus_0,2)
            if abs(taus_0(index(ii),jj)-taus_1(index(ii),jj)) > tol
                ixs0=ixs0+1;
                IIb0(ixs0,1)=index(ii);
                IIb0(ixs0,2)=jj;
            end
        end
    end
    
    %check that tausb is made all of zeros
    if max(max(abs(tausb_0))) > 0
        error('(check_taus) tausb has non-zero entries. Verify whether this should indeed be the case')
    end

    if ix0 == 0 && ix1 == 0 && ixs0 == 0 && ixs1 == 0
        disp(' Congratulations....all the taus are correct!')
    else
        error('fatal(check_taus) taus did not pass the check')
    end
    
    xx=imap(xx); %revert back to the xx with which we came into this file
end