function [tauu] = findtaugm1(shk,taushock,II,l_psi)
%find the location in psi(t) of the shock with numerical id, shk
%if shk is not in psi(t), then return tau=0
if max(taushock == shk) == 1
    id=II(find(taushock==shk));
    tauu=zeros(1,l_psi);
    tauu(id+1)=1; %we need to select g(t-1)
else
    tauu=zeros(1,l_psi);
end
