loadupnonlin

ppnonlin=[zp1'; z0'; zm1'; psip1'; psip0'];

%verify that the steady states are correct:
[ffnonlin] = nonlin(ppnonlin,params,pi);

tt1bis = [tt1, tt1(end)+1, tt1(end)+2, tt1(end)+3, tt1(end)+4, tt1(end)+5, tt1(end)+6];
if max(abs(ffnonlin(tt1bis ))) > .2e-7
    error('fatal (gotest) steady state failed accuracy check')
end

%get the numerical derivatives:
[QQnonlin]=derivative(ppnonlin,params,pi,'nonlin');

%convert the numerical derivatives to 'hats'...
for ii = 1:length(ppnonlin)
    QQnonlin(:,ii)=QQnonlin(:,ii)*ppnonlin(ii);
end

axx1 = QQnonlin(31,:)/QQnonlin(31,nn+1);
axx1 = sort(axx1,'descend');
axx = QQnonlin(32,:)/QQnonlin(32,nn+2);
axx = sort(axx,'descend');
for ij = 2:length(axx1) 
    if axx(ij) >.2e-6 | axx1(ij) >.2e6
        error('fatal, check on nonlinear pricing equation failed')
    end
end

QQnonlin(1,:) = QQnonlin(33,:)-QQnonlin(34,:);
QQnonlin(1,:) = QQnonlin(1,:)/QQnonlin(1,nn+4+1);

QQnonlin(19,:) = QQnonlin(35,:)-QQnonlin(36,:);
QQnonlin(19,:) = QQnonlin(19,:)/QQnonlin(19,nn+4+tts(tt2==19));
axx2 = alpha_10(19,19);
alpha_00(19,:) = alpha_00(19,:)/axx2;
alpha_10(19,:) = alpha_10(19,:)/axx2;
alpha_20(19,:) = alpha_20(19,:)/axx2;
beta_00(19,:) = beta_00(19,:)/axx2;
beta_10(19,:) = beta_10(19,:)/axx2;

QQ=QQnonlin(1:(size(QQnonlin,1)-6),[1:nn, ((nn+4)+1):(nn+4)+nn, (2*(nn+4)+1):2*(nn+4)+nn, (3*(nn+4)+1):(3*(nn+4)+21), (3*(nn+4)+21+1):length(QQnonlin)] );

%

%line 32: wage distortion dynamic equation.
%function of wstar (z0(30) for date t and z1(30) for date t)
%line 31: price distortion dynamic equation
%function of pstar (z0(29) for date t and z1(29) for date t-1)

