function [tt,compfilt] = plotstuff(XXXsmooth,xismooth,laborwedge,laborwedgea,effwedge,net,dmoney3, ...
    dmoney1,dinvest,dout,infl,dwage,dcons,Spread1,money1,money3,output,invest,cons, ...
    wage,price,laborwedgek2,laborwedgek2a,effwedgek2,netk2,dmoney3k2,dmoney1k2,dinvestk2,doutk2, ...
    inflk2,dwagek2,dconsk2,Spread1k2,money1k2,money3k2,outputk2,investk2,consk2,wagek2,pricek2, ...
    hours,hoursk2,capacity,capacityk2,btott,btottk2,dbtott,dbtottk2,Ra_series,Ra_seriesk2,Re_series,Re_seriesk2,Pe_series,Pe_seriesk2, ...
    date,tauvar,XXX,m1,currdep,Ra,dm,m3,l_z,muzstar,Pe,Rb,Re,alpha,govc,dgovc,idef,didef,govck2,dgovck2, ...
    idefk2,didefk2,pi,oilp,doilp,oilpk2,doilpk2,Spread2,Spread2k2,dnet,dnetk2,reserves,reservesk2,dreserves,dreservesk2)

compfilt=0; %=1 compare the actual data with the filtered data and the smoothed (two-sided filtered) data; =0 drop the filtered data
if compfilt ==1
    error('fatal (plotstuff) compfilt=1 and code might not be ready for this')
end

ref=1; % ~=1:impose that the variables in the model and in the data take on the same value in the specified Quarter; =1, do nothing

if ref==1
    rf=0;
else
    rf=1;
end
laborwedgek2  = laborwedgek2+laborwedge(ref)*rf-laborwedgek2(ref)*rf;
laborwedgek2a = laborwedgek2a+laborwedgea(ref)*rf-laborwedgek2a(ref)*rf;
effwedgek2    = effwedgek2+effwedge(ref)-effwedgek2(ref);
netk2         = netk2+net(ref)*rf-netk2(ref)*rf;
inflk2        = inflk2+infl(ref)*rf-inflk2(ref)*rf;
pricek2=pricek2+price(ref)*rf-pricek2(ref)*rf;
outputk2=outputk2+output(ref)*rf-outputk2(ref)*rf;
wagek2=wagek2+wage(ref)*rf-wagek2(ref)*rf;
investk2=investk2+invest(ref)*rf-investk2(ref)*rf;
money1k2=money1k2+money1(ref)*rf-money1k2(ref)*rf;
money3k2=money3k2+money3(ref)*rf-money3k2(ref)*rf;
btottk2=btottk2+btott(ref)*rf-btottk2(ref)*rf;
consk2=consk2+cons(ref)*rf-consk2(ref)*rf;
Spread1k2=Spread1k2+Spread1(ref)*rf-Spread1k2(ref)*rf;
hoursk2=hoursk2+hours(ref)*rf-hoursk2(ref)*rf;
capacityk2=capacityk2+capacity(ref)*rf-capacityk2(ref)*rf;
%Rb_seriesk2=Rb_seriesk2 + Rb_series(ref)*rf - Rb_seriesk2(ref)*rf;
Ra_seriesk2=Ra_seriesk2 + Ra_series(ref)*rf - Ra_seriesk2(ref)*rf;
Re_seriesk2=Re_seriesk2 + Re_series(ref)*rf - Re_seriesk2(ref)*rf;
Pe_seriesk2=Pe_seriesk2 + Pe_series(ref)*rf - Pe_seriesk2(ref)*rf;
govck2=govck2+govc(ref)*rf-govck2(ref)*rf;
idefk2=idefk2+idef(ref)*rf-idefk2(ref)*rf;
oilpk2=oilpk2+oilp(ref)*rf - oilpk2(ref)*rf;
%capitk2=capitk2+capit(ref)*rf - capitk2(ref)*rf;
Spread2k2=Spread2k2+Spread2(ref)*rf-Spread2k2(ref)*rf;
reservesk2= reservesk2+reserves(ref)*rf-reservesk2(ref)*rf;


figure
n1=4;
n2=4;
tt=5:length(date); %first 4 quarters are lost in computing annual growth rates

plttkalout(n1,n2,compfilt,net,[],date,netk2,infl,[],inflk2,price,pricek2,XXX,[],XXXsmooth, ...
    output,[],outputk2,wage,[],wagek2,invest,[],investk2,money1,[],money1k2,money3,[],money3k2,cons,[],consk2, ...
    Spread1,Spread1k2,hours,hoursk2,capacity,capacityk2,btott,btottk2,dbtott,dbtottk2,Ra_series,Ra_seriesk2,Re_series,Re_seriesk2, ...
    Pe_series,Pe_seriesk2,tt,tauvar,currdep,Pe,Rb,Ra,Re,ref,rf,dmoney3,dmoney1,dinvest,dout,dwage,dcons, ...
    dmoney3k2,dmoney1k2,dinvestk2,doutk2,dwagek2,dconsk2,govc,dgovc,idef,didef,govck2,dgovck2,idefk2,didefk2,pi, ...
    oilp,doilp,oilpk2,doilpk2,Spread2,Spread2k2,dnet,dnetk2,reserves,reservesk2,dreserves,dreservesk2)

do_tfp=0;
if do_tfp ==1
    %construct TFP
    caphat=xismooth(l_z+21,:); %kbarhat(t)
    ttt=1:length(caphat);
    cap=caphat+ttt*log(muzstar);
    tfpk2=outputk2 - alpha*cap-(1-alpha)*hoursk2;

    %load data on log(TFP)
    %tfp = load .... %to be done
    tfpk2  = tfpk2 + tfp(ref)*rf - tfpk2(ref)*rf; %normalise TFP

    %construct the gap between marginal product of labor and real wage: log(Y/N)-log(W/P)
    log_y_nwk2 = -( XXXsmooth(6,:)+XXX(6,ref)*rf-XXXsmooth(6,ref)*rf + hoursk2);
    log_y_nw = -( XXX(6,:)+hours);

    figure, orient landscape
    n1=2;
    n2=3;
    title_fig='Figure : Wedges in Estimated Model (dotted line) and Data (solid line)';

    subplot(n1,n2,1)
    %plot(date(tt),tfpdat(tt),date(tt),tfpk2(tt),date(tt),tfpk2(tt),'.')
    plot(date(tt),tfpk2(tt),date(tt),tfpk2(tt),'.')
    title('Log(TFP) as Log(gnp/[(k^\alpha)*(l^{1-\alpha})])')
    set (gca,'XTick',[0 21])
    axis tight

    subplot(n1,n2,2)
    plot(date(tt),log_y_nw(tt),date(tt),log_y_nwk2(tt),date(tt),log_y_nwk2(tt),'.')
    title('Log(Y/L)-Log(W/P)')
    set (gca,'XTick',[0 21])
    axis tight

    subplot(n1,n2,3)
    plot(date(tt),laborwedgea(tt),date(tt),laborwedgek2a(tt),date(tt),laborwedgek2a(tt),'.')
    title('Log(W/P)-Log(C)-Log(L)')
    axis tight

    tyt = [tt(1):tt(end-1)]; %we plot the data up to tt(end-1) as the MU(C) makes use of C(t+1) given the presence of habit formation
    subplot(n1,n2,4)
    plot(date(tyt),laborwedge(tyt),date(tyt),laborwedgek2(tyt),date(tyt),laborwedgek2(tyt),'.')
    title('Log(W/P)+Log(MU(C))-Log(L)')
    axis tight


    % subplot(n1,n2,n1*n2)
    % text(.01,.9,'Notes:')
    % text(.01,.7,'(i) Undetrended Total Factor Productivity (TFP) ')
    % text(.01,.60,'               TFP = gnp/[(k^\alpha)*(l^{1-\alpha})]')
    % text(.01,.50,'(ii) c - consumption of nondurables and services, l - total employment')
    % text(.01,.45,'     wage - economy wide hourly wage rate')
    % set (gca,'XTick',[0 20])
    % set (gca,'YTick',[0 1])
    % vaxis = axis; %get the current axis value
    % xmin = vaxis(1);
    % xmax= vaxis(2);
    % ymin = vaxis(3);
    % ymax = vaxis(4);
    % hold on
    % plot([xmin xmax],[ymin ymin],'w-') %bottom
    % plot([xmin xmin],[ymin ymax],'w-') % left
    % %%%%plot([xmin xmax],[ymax ymax],'w-') %top
    % plot([xmax xmax],[ymin ymax],'w-') %right

    hout=suptitle(title_fig);
end
