function [ffm,Ra,her,Rm,dm,mb] = findm(m,x,theta,Re,R,tau,chorse,chii,tauD,pi,muzstar,beta,c,sigmaq,lamz,v,uzc,tauc,pref)

Ra = fRa(m,x,theta,Re);
if Ra < 0;
    error('(findm) Ra<0'),
end

%equation aa15
her=(1+R/Ra)/((1-tau)*(R/Ra)-tau);
if her < 0 & entr ~= -1
    ix(9)=1;
    error('(findm) her<0')
end

% equation for Rm aa8
Rm = Re - chorse*R/(her*tau+1);
if Rm < 0
    error('(findm) Rm<0')
end

if pref == 0%ACEL preferences
    
%     %equation aa20:
%     lamz=uzc/(1+tauc);
%     
%     %FOC for Dm over FOC M
%     bb = ((1-chii)*theta/m)-((1-chii)*(1-theta)/(1-m));
%     dm = chii*(1-tauD)*Ra / ( bb*pi*( (muzstar/beta)- ((1+(1-tauD)*Rm)/pi)) );
%  
%     %solve aa20 for mb:
%     aab=v*(( ((1/m)^((1-chii)*theta)) * ((1/(1-m))^((1-chii)*(1-theta))) * (1/dm)^chii)^(1-sigmaq))*bb;
%     mb=muzstar*pi*(lamz*(1-tauD)*Ra/aab)^(1/(sigmaq-2));
%     if mb < 0 | imag(mb) > .1e-10 | dm<0
%         error('fatal (oldmblamz) mb or dm is negative')
%     end
    
elseif pref == 1 %benchmark preferences
    %equation for dm 
    bb = ((1-chii)*theta/m)-((1-chii)*(1-theta)/(1-m));
    dm = chii*(1-tauD)*Ra / ( bb*pi*( (muzstar/beta)- ((1+(1-tauD)*Rm)/pi)) );
    
    [aa] = faabb(c,m,theta,x,sigmaq,chii,dm);
    
    %use FOC for M to find mb
    mb= (lamz*((1-tauD)*Ra)/(v*aa*bb*(pi*muzstar)^(2-sigmaq)))^(1/(sigmaq-2));
    
    %verify whether the value of m satisfies the FOC for C
    ffm=(uzc-(1+tauc)*lamz)-v*(aa/c)*(mb/(pi*muzstar))^(sigmaq-1);
    
    if mb < 0 | dm < 0
        error('(findm) mb < 0 | dm < 0')
    end
end
