%this program goes to find a previously solved model. The program does some basic consistency
%checks (actually, it repeats consistency checks already done when A and B were created in the first place). 
%The consistency checks amount to verifying that A is the root of a certain matrix polynomial, and that A and B together
%imply that a certain matrix, F-tilde is zero. A detailed discussion  of
%this appears in the technical manuscript corresponding to this model. 

load([outfolder '\model']); 

%verify that the A's are the root of the appropriate matrix polynomial...
Q=alpha_0*A*A+alpha_1*A+alpha_2;
qq=max(max(abs(Q)));
if qq > accuracy 
    keyboard
    %error('fatal (simulate) solveaa failed to solve for A')
end

checkB