function [alf,taum,taub,taus,tausb] = linear1(tau,her,ksi,Rb,Re,c,y,i,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pi,g,ev, ...
    Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,M,m1,upsil,currdep,Ra,dm,m3,l_z,demean,mm,taushock,parstoch,A, ...
    B1,B2,duration1,rho,beta,tauvar,gamma,alpha,R,tt2,entr,tauC,duration2,taud,params)

bb=0;
if entr==2; entr=1; bb=1; end
if entr==-4; entr=-3; bb=1; end

begin = params(71);
calvohours = params(79);
do_qavrg = params(90);

l_xxx = 20; %number of variables in XXX vector of data

tts = [1:31]; %full size of zt when entr=1

%first, find the location of the exogenous shocks in psi(t), that are needed.
%it is assumed that psi(t) only includes the shocks used in the analysis.
l_psi = size(B1,2);
[vbname,signal_on,II,IIII]=findnum(taushock,parstoch,l_psi,[]);


%find the location in psi(t) of the reserve requirement shock (this is
%shock #2 in our list of fundamental shocks)
shk=2;
[tauures] = findtau(shk,taushock,II,l_psi);
%find the location of psil (fraction of wage bill to be financed)
%shock #3 in our list of fundamental shocks)
shk=3;
[tauupsil] = findtau(shk,taushock,II,l_psi);
tauupsil = tauupsil*M(3,3);%note:we have multiplied tauupsil by (1-psil) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M
%find the location in psi(t) of psilhat(t-1)...
shk=3;
[tauupsilm1] = findtaulagged(shk,taushock,II,l_psi);
tauupsilm1 = tauupsilm1*M(3,3);%note:we have multiplied tauupsilm1 by (1-psil) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M
%find the location of psik (fraction of capital rental bill to be financed)
%shock #4 in our list of fundamental shocks)
shk=4;
[tauupsik] = findtau(shk,taushock,II,l_psi);
tauupsik = tauupsik*M(4,4);%note:we have multiplied tauupsik by (1-psik) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M
%find the location in psi(t) of psikhat(t-1)...
shk=4;
[tauupsikm1] = findtaulagged(shk,taushock,II,l_psi);
tauupsikm1 = tauupsikm1*M(4,4);%note:we have multiplied tauupsikm1 by (1-psik) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M

%find the location in psi(t) of ksi
shk=5;
[tauuksi] = findtau(shk,taushock,II,l_psi);
tauuksi = tauuksi*M(5,5);%note:we have multiplied tauupsik by (1-psik) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M

%find the location in psi(t) of xb (technology shock in banking sector)
shk=6;
[tauuxb] = findtau(shk,taushock,II,l_psi);
%find the location in psi(t) of muuphat...
shk=7;
[tauumuup] = findtau(shk,taushock,II,l_psi);
%find the location in psi(t) of muupha(t-1)...
shk=7;
[tauumuupm1] = findtaumuupm1(shk,taushock,II,l_psi);
%find the location in psi(t) of ghat...
shk=13;
[tauug] = findtau(shk,taushock,II,l_psi);
%find the location in psi(t) of gha(t-1)...
shk=13;
[tauugm1] = findtaugm1(shk,taushock,II,l_psi);
%find the location in psi(t) of taud
shk=15;
[tauutaud] = findtau(shk,taushock,II,l_psi);   
tauutaud = tauupsil*M(15,15);%note:we have multiplied tauutaud by (1-taud) as this shock lies in the unit interval and we have adjusted betas in makealphabeta accordingly through the matrix M
%find the location in psi(t) of the unit root technology shock
shk=16;
[tauumuz] = findtau(shk,taushock,II,l_psi);    
%find the location in psi(t) of muzhat(t-1)...
shk=16;
[tauumuzm1] = findtaulagged(shk,taushock,II,l_psi);
%find the location in psi(t) of epsilonhat(t)...
shk=18;
[tauuepsi] = findtau(shk,taushock,II,l_psi); 
%find the location in psi(t) of epsilonhat(t-1)...
shk=18;
[tauuepsim1] = findtaulagged(shk,taushock,II,l_psi);
%find the location in psi(t) of tauC(t)
shk=20;
[tauutauC] = findtau(shk,taushock,II,l_psi);    
%find the location in psi(t) of tauChat(t-1)...
shk=20;
[tauutauCm1] = findtaulagged(shk,taushock,II,l_psi);
%find the location in psi(t) of sigma(t-1) 
shk=21;
[tauusigma] = findtausigmam1(shk,taushock,II,l_psi);
%[tauusigma] = findtau(shk,taushock,II,l_psi);
%find the location in psi(t) of zetachat(t)...
shk=22;
[tauuzetac] = findtau(shk,taushock,II,l_psi); 
%find the location in psi(t) of tau0hat(t)...
shk=24;
[tauutau0] = findtau(shk,taushock,II,l_psi); 
%find the location in psi(t) of tau0hat(t-1)...
shk=24;
[tauutau0m1] = findtaulagged(shk,taushock,II,l_psi);
%find location in psi(t) of termhat(t);
shk=25;
[tauuterm]= findtau(shk,taushock,II,l_psi);
    

tausy= (g/y)*tauug - (i/y)*tauumuup;
if entr > -1
    tausR=(1-tau*her/(tau*her+1))*(-((1/(1-ksi) + log(ev)))*ksi*tauuksi + tauuxb);
end

if entr>-1
    V1=y/m1;
    if begin ==1
        tausV1 = (V1/y)*(mb/(pi*muzstar) + psik*rk*k/(upsil*muzstar))*tauumuz -(V1/y)*psil*w*l*tauupsil -(V1/(muzstar*y*upsil))*(psik*rk*k)*tauupsik;
    elseif begin ==0
        tausV1 = (V1/y)*( psik*rk*k/(upsil*muzstar))*tauumuz -(V1/y)*psil*w*l*tauupsil -(V1/(muzstar*y*upsil))*(psik*rk*k)*tauupsik;
    end
end

if entr ==1 || entr==-3
    tausp=(Pe*Gs*sigma/G)*tauusigma;
end

l_z=size(A,1);
At=[A B1*rho+B2;zeros(l_psi,l_z) rho];
taulam=zeros(1,l_z+l_psi);
taulam(tts(tt2==15))=1;
taure=zeros(1,l_z+l_psi);
taure(tts(tt2==22))=1;
taumuz=[zeros(1,l_z) tauumuz];
tautaud_lr= [zeros(1,l_z) tauutaud];
tauzetac_lr = [zeros(1,l_z) tauuzetac];
tauterm_lr = [zeros(1,l_z) tauuterm];
%tauterm2_lr = [zeros(1,l_z) tauuterm2];
taupi=[1 zeros(1,l_z+l_psi-1)];
IA=eye(size(At))-At;

if bb==0
    taunominalrate = taure;
elseif bb==1
    taunominalrate = (1+Re)/Re*(taure + taupi*At);
end

if max(tauvar==12)==1
    if entr ==-2
        error('fatal (linear) you have included the long rate but lambdaz is not in z_t when entr=-2. You need to adjust the code')
    end
     Atn=At^duration1;
     IAn=eye(size(At))-Atn;

     taulong= (Re/duration1)*(pi*muzstar/(pi*muzstar-beta))*(tauzetac_lr + taulam + (taupi+taumuz-tauterm_lr)*(At/IA)*IAn-taulam*Atn -tauzetac_lr*Atn) +(Re*taud/(1-taud))*tautaud_lr*Atn - Re*taunominalrate; %we append here term-spread shock
else %if long-term rate is not included in XXX, we skip some computations imposing taulong=zeros
     taulong=zeros(1,l_z+l_psi);
end
if max(tauvar==19)==1
    if entr ==-2
        error('fatal (linear) you have included the long rate but lambdaz is not in z_t when etr=-2. You need to adjust the code')
    end
    Atn2=At^duration2;
    IAn2=eye(size(At))-Atn2;

    taulong2= (Re/duration2)*(pi*muzstar/(pi*muzstar-beta))*(tauzetac_lr + taulam + (taupi+taumuz-tauterm_lr)*(At/IA)*IAn2-taulam*Atn2 -tauzetac_lr*Atn2) +(Re*taud/(1-taud))*tautaud_lr*Atn2 - Re*taunominalrate; %we append here term-spread shock
else 
    taulong2=zeros(1,l_z+l_psi);
end
At1=taulong([1:l_z]);
At2=taulong([l_z+1:l_z+l_psi]);

At1_2=taulong2([1:l_z]);
At2_2=taulong2([l_z+1:l_z+l_psi]);

%go for taum
taum=zeros(l_xxx,l_z);

if entr ==1 || entr==-3
    taum(1,tts(tt2==8))=1; %net worth
else
    if do_qavrg ==0
        taum(1,tts(tt2==9))=1; %marginal q
    elseif do_qavrg ==1
        taum(1,tts(tt2==31))=1; %average q
    end
end
taum(2,tts(tt2==1))=1; %inflation

if calvohours==0
    taum(3,tts(tt2==20))=1; %hours
else
    taum(3,tts(tt2==30))=1; %employment
end

% if entr>-1
%     taum(4,tts(tt2==13))=1; %Rb
%     taum(4,tts(tt2==11))=-(1 - (tau*her/(tau*her+1)))*ksi; %ev
%     taum(4,:)=taum(4,:)*Rb;
% end

tauy=zeros(1,l_z); %gdp
tauy(tts(tt2==18))=c/y;
tauy(tts(tt2==4))=i/y;
taum(5,:)=tauy;

taum(6,tts(tt2==19))=1; %wages
taum(7,tts(tt2==4))=1; %investment

if entr >-1
    tauv1=zeros(1,l_z);
    if begin ==1
        tauv1(tts(tt2==1)) = (V1/y)*mb/(pi*muzstar);
    elseif begin ==0
        tauv1(tts(tt2==12)) = (V1/y)*mb;
    end
    tauv1(tts(tt2==19))=(V1/y)*psil*w*l;
    tauv1(tts(tt2==20))= (V1/y)*psil*w*l;
    tauv1(tts(tt2==3))=(V1/y)*(psik*rk*k/(muzstar*upsil));
    tauv1(tts(tt2==5))=(V1/y)*(psik*rk*k/(muzstar*upsil));

    taum(9,tts(tt2==26))=1; %m3
end

taum(10,tts(tt2==18))=1; %consumption
if entr ==1 || entr==-3
    taum(11,tts(tt2==6))=Pe*Gp*omegabar/G; %risk premium
    taum(11,tts(tt2==7))=(Pe*Rk/(1+Rk));
end

taum(12,:)= At1; %spread1

taum(19,:)= At1_2; %spread2

% taum(12,1) = -currdep*psil*pi*muzstar*w*l/(m*mb) - currdep*psik*rk*pi*k/(m*upsil*mb);
% taum(12,3)=-currdep*psik*rk*pi*k/(m*upsil*mb);
% taum(12,5)=taum(12,3);
% taum(12,19)=-currdep*psil*pi*muzstar*w*l/(m*mb);
% taum(12,16)=1+currdep;
% taum(12,20)=taum(12,19);
if entr >-1
    taum(13,tts(tt2==17)) = Ra; %Ra
end
if entr==1 || entr==0 || entr==-1 || entr==-3
    taum(14,tts(tt2==22)) = Re; %Re
    if bb==1
        taum(14,:) = Re*taunominalrate(1:l_z);
    end
elseif entr ==-2
    taum(14,tts(tt2==13)) = R;
end
taum(15,tts(tt2==5))  = 1; %capacity

%reserves
if entr==1
  e_e   = mb*(1-tau)*(1-m)/(pi*muzstar) - tau*(psil*w*l + psik*rk*k/(upsil*muzstar)); %steady state value
  taum(20,tts(tt2==1))   = -(1-tau)*(1-m)*mb/(e_e*pi*muzstar); 
  taum(20,tts(tt2==16))  = -(1-tau)*mb*m/(e_e*pi*muzstar);
  taum(20,tts(tt2==3))   = -tau*psik*rk*k/(e_e*upsil*muzstar);
  taum(20,tts(tt2==5))   = -tau*psik*rk*k/(e_e*upsil*muzstar);
  taum(20,tts(tt2==19))  = -tau*psil*w*l/e_e;
  taum(20,tts(tt2==20))  = -tau*psil*w*l/e_e;
end

if fdiff == 0
    if entr ==1 || entr==-3
        taum(1,:) = taum(1,:)-tauy;
    end
    taum(6,:)     = taum(6,:)-tauy;
    taum(7,:)     = taum(7,:)-tauy;
    if entr >= -1
        taum(8,:)     = (tauy-tauv1);
    end
    if entr > -1
        taum(9,:)     = (tauy-taum(9,:));
    end
    taum(10,:)    = taum(10,:)-tauy;
    %taum(17,tts(tt2==1)) = 1;
    if max(tauvar==4)==1
        error('(linear) fdiff=0 and you have included loans. Code not ready for this')
    end
end
if fdiff ==1
    if entr > -1
        if begin ==1
            taum(8,tts(tt2==1))  = -mb/(m1*pi*muzstar);
        elseif begin ==0
            taum(8,tts(tt2==12))  = mb/m1;
        end
        taum(8,tts(tt2==3))  = psik*rk*k/(m1*upsil*muzstar);
        taum(8,tts(tt2==5))  = psik*rk*k/(m1*upsil*muzstar);
        taum(8,tts(tt2==19)) = psil*w*l/m1;
        taum(8,tts(tt2==20)) = psil*w*l/m1 ;
    end
    
    if entr ==1 || entr==-3
        taum(4,tts(tt2==28)) = 1; %btot
    end
end

%now go for taub
taub=zeros(l_xxx,l_z);
    
taub(5,:)=-tauy;

if fdiff ==0
    if entr > -1
        if begin ==1
        taub(8,tts(tt2==12)) = -(V1/y)*mb/(pi*muzstar);
        end
        taub(8,tts(tt2==21)) = -(V1/y)*psik*rk*k/(muzstar*upsil);
    end
end
if entr ==1 || entr==-3
    taub(11,tts(tt2==8)) = Pe*n/(k-n);
    taub(11,tts(tt2==9)) = -Pe*n/(k-n);
    taub(11,tts(tt2==21))= -Pe*n/(k-n);
end

if fdiff == 1
    if entr ==1 || entr==-3
        taub(1,tts(tt2==8)) = -1;
    elseif entr ==-2
        if do_qavrg ==0
            taub(1,tts(tt2==9)) = -1; %marginal q
        elseif do_qavrg ==1
            taub(1,tts(tt2==31)) = -1; %average q
        end
    end
    if entr ==1 || entr==-3
        taub(4,tts(tt2==28)) = -1;
    end
    taub(6,tts(tt2==19)) = -1;
    taub(7,tts(tt2==4))  = -1;
    taub(10,tts(tt2==18))= -1; 
    
    if entr > -1
        taub(9,tts(tt2==26)) = -1;

        if begin ==1
            taub(8,tts(tt2==1))  = mb/(m1*pi*muzstar);
            taub(8,tts(tt2==12)) = mb/(m1*pi*muzstar);
            taub(8,tts(tt2==27)) = -mb/(m1*pi*muzstar);
        elseif begin ==0
            taub(8,tts(tt2==12)) = -mb/m1;
        end
        taub(8,tts(tt2==3))  = -psik*rk*k/(m1*upsil*muzstar);
        taub(8,tts(tt2==5))  = -psik*rk*k/(m1*upsil*muzstar);       
        taub(8,tts(tt2==19)) = -psil*w*l/m1;
        taub(8,tts(tt2==20)) = -psil*w*l/m1 ;
        taub(8,tts(tt2==21)) = psik*rk*k/(m1*upsil*muzstar);        
        taub(8,tts(tt2==29)) = -psik*rk*k/(m1*upsil*muzstar);
    end
end

%reserves
if entr==1
  taub(20,tts(tt2==1))   = (1-tau)*(1-m)*mb/(e_e*pi*muzstar); 
  taub(20,tts(tt2==16))  = (1-tau)*mb*m/(e_e*pi*muzstar);
  taub(20,tts(tt2==3))   = tau*psik*rk*k/(e_e*upsil*muzstar);
  taub(20,tts(tt2==5))   = tau*psik*rk*k/(e_e*upsil*muzstar);
  taub(20,tts(tt2==12))  = (1-tau)*(1-m)*mb/(e_e*pi*muzstar); 
  taub(20,tts(tt2==19))  = tau*psil*w*l/e_e;
  taub(20,tts(tt2==20))  = tau*psil*w*l/e_e;
  taub(20,tts(tt2==21))  = -tau*psik*rk*k/(e_e*upsil*muzstar);
  taub(20,tts(tt2==27))  = -(1-tau)*(1-m)*mb/(e_e*pi*muzstar);
  taub(20,tts(tt2==29))  =  tau*psik*rk*k/(e_e*upsil*muzstar);
end


%go for taus
taus=zeros(l_xxx,l_psi);

taus(2,:)= (tauC/(1+tauC))*(tauutauC -tauutauCm1);
%taus(4,:) = Rb*tausR;

if fdiff ==0
    if entr ==1 || entr==-3
        taus(1,:) =-tausy;
    end 
    taus(6,:) =-tausy;
    taus(7,:) =-tausy;
    taus(10,:)=-tausy;
    if entr > -1
        taus(8,:) =tausy+tausV1;
        taus(9,:) =tausy;
    end
    taus(16,:) = tauug - tauugm1 + tauumuz;
    taus(17,:) = -tauumuup + tauumuupm1;
    taus(18,:) = tauutau0 - tauutau0m1;
end
if fdiff ==1
    if entr ==1 || entr==-3 || entr==-2
        taus(1,:) = tauumuz;
    end
    if entr ==1 || entr==-3
        taus(4,:) = tauumuz;
    end
    taus(6,:) = tauumuz;
    taus(7,:) = tauumuz;
    taus(10,:) = tauumuz;
    taus(16,:) = tauug - tauugm1 + tauumuz;
    taus(17,:) = -tauumuup + tauumuupm1;
    taus(18,:) = tauutau0 - tauutau0m1;
    if entr > -1
        taus(9,:) = tauumuz;
        if begin ==1
              taus_m1_0  = 1-mb/(m1*pi*muzstar) -psik*rk*k/(m1*upsil*muzstar); %coefficient on taus that selects shocks present in M1
              taus_m1_m1 = mb/(m1*pi*muzstar) +psik*rk*k/(m1*upsil*muzstar);
        elseif begin ==0
              taus_m1_0  = 1-psik*rk*k/(m1*upsil*muzstar);
              taus_m1_m1 = psik*rk*k/(m1*upsil*muzstar);
        end
        taus(8,:) = (psil*w*l/m1)*tauupsil -(psil*w*l/m1)*tauupsilm1 + (psik*rk*k/(m1*upsil*muzstar))*tauupsik  -(psik*rk*k/(m1*upsil*muzstar))*tauupsikm1 + taus_m1_0*tauumuz + taus_m1_m1*tauumuzm1;
    end
end

taus(5,:) =tausy+tauumuz - (g/y)*tauugm1 + (i/y)*tauumuupm1;
if entr ==1 || entr==-3
    taus(11,:)=tausp; 
end
taus(12,:)=At2;

taus(19,:)=At2_2;

if bb==1
    taus(14,:) = Re*taunominalrate(l_z+1:l_z+l_psi);
end

%reserves
if entr==1
    taus(20,:) = -tauupsil*tau*psil*w*l/e_e + tauupsilm1*tau*psil*w*l/e_e ...
                 -tauupsik*tau*psik*rk*k/(e_e*upsil*muzstar) + tauupsikm1*tau*psik*rk*k/(e_e*upsil*muzstar) ...
                 -tauumuz*((1-tau)*(1-m)*mb/(e_e*pi*muzstar) - tau*psik*rk*k/(e_e*upsil*muzstar) -1) ...
                 +tauumuzm1*((1-tau)*(1-m)*mb/(e_e*pi*muzstar) - tau*psik*rk*k/(e_e*upsil*muzstar));
end

%now go for tausb
tausb=zeros(l_xxx,l_psi);
%tausb(5,:)=-tausy;

% go for alfa (i.e. the mean)
alf=zeros(l_xxx,1);
if demean ==0  %if =0 remove the mean of the variables which are not in mm; if =1, demean everything. In this case, the previous line has already set alf=0)
    alf(1)=log(muzstar);
    alf(2)=log(pi);
    alf(3)=l; 
    %alf(4)=Rb;
    alf(4)=log(muzstar);
    alf(5)=log(muzstar);
    alf(6)=log(muzstar);
    alf(7)=log(muzstar);
    alf(8)=log(muzstar);
    alf(9)=log(muzstar);
    alf(10)=log(muzstar);
    alf(11)=Pe;
    alf(12)=0;
    alf(13)=Ra;
    alf(14)=Re;
    alf(15)=0; %we don't try to match the mean of capacity utilization 
    alf(16)=log(muzstar);
    alf(17)=log(pi)-log(upsil);
    alf(19)=Re;
    alf(20)=log(muzstar);
    if fdiff == 0
        alf(1)=log(n/y); 
        alf(6)=log(w/y); 
        alf(7)=log(i/y);  
        alf(10)=log(c/y);
        if entr > -1
            alf(8)=log(V1);
        end
        alf(9)=log(y/m3);
        alf(16)=log(muzstar);
        alf(17)=log(pi)-log(upsil);
    end
    alff=zeros(length(alf),1);
    alff(mm)=alf(mm);%we don't try to match the mean of n/y, l and w/y
    alf=alff;
end

% alf  = 100*alf;

%the adjustments to take into account change of variables for shocks required to lie in unit interval have been done directly while constructing the taus
