function logf = logigammapdf(x,a,d)

if x <0.00000001;
    logf = -6e10;
else
    old=1;
    if old==1
        s=a*(d+2);
        G=gamma(d/2);
        C=G*(2/s)^(d/2);
        f=(1/C)*x^(-(d+2)/2)*exp(-s/(2*x));
        logf=log(f);
    else
        f = (2/gamma(d/2))*((1/2*d*a^2)^(d/2))*(x^(-(d+1)))*exp((-d*a^2)/(2*x^2));
        logf = log(f);
    end
end
