function maketablerelvariance(cc,relVAR,country,name,label,ss,fid,itest,hp,ttitle,ttable1,ttable2,tabletitle,outfolder)

if itest==1;
    name='test.tex'
    fid = fopen([outfolder '\' name],'w');

    fprintf(fid,'%%\\usepackage{amsfonts}\n');
    fprintf(fid,'%%\\usepackage{amssymb}\n');
    fprintf(fid,'%%\\usepackage{graphicx}\n');
    fprintf(fid,'%%\\usepackage{srav4}\n');
    fprintf(fid,'%%\\input{lefttag.sty}\n');

    fprintf(fid,'\\documentclass[12pt]{article}\n');
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    fprintf(fid,'\\usepackage{amsmath}\n');
    fprintf(fid,'\\usepackage{hyperref}\n');
    fprintf(fid,'\\usepackage{graphicx}\n');

    fprintf(fid,'\\setcounter{MaxMatrixCols}{10}\n');
    fprintf(fid,'%%TCIDATA{OutputFilter=LATEX.DLL}\n');
    fprintf(fid,'%%TCIDATA{Version=5.50.0.2890}\n');
    fprintf(fid,'%%TCIDATA{<META NAME="SaveForMode" CONTENT="1">}\n');
    fprintf(fid,'%%TCIDATA{BibliographyScheme=Manual}\n');
    fprintf(fid,'%%TCIDATA{Created=Mon May 15 13:43:50 2000}\n');
    fprintf(fid,'%%TCIDATA{LastRevised=Tuesday, July 22, 2008 17:44:24}\n');
    fprintf(fid,'%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">}\n');
    fprintf(fid,'%%TCIDATA{Language=American English}\n');
    fprintf(fid,'%%TCIDATA{CSTFile=article.cst}\n');

    fprintf(fid,'\\input{tcilatex}\n');
    fprintf(fid,'\\begin{document}\n');

end

ix=1;
for ii = ttable1
   f1(ix)=(ii-1)*2+1;
   f1(ix+1)=(ii-1)*2+2;
   ix=ix+2;
end

%we don't yet have the standard error on the standard deviation of output.
f1=[f1(1) f1(3:end)];
ix=1;
for ii = ttable2
   f2(ix)=(ii-1)*2+1;
   f2(ix+1)=(ii-1)*2+2;
   ix=ix+2;
end

%normal DSGE statistics
maketable(ttable1,ttitle,ss,relVAR,cc,f1,fid,hp,label,0,tabletitle,1);

%financial statistics
maketable(ttable2,ttitle,ss,relVAR,cc,f2,fid,hp,label,1,tabletitle,1);

if itest==1
    fprintf(fid,'\\end{document}\n');
    fclose(fid);
end