plot_bands = 0; %=1 plot confidence bands; =0 plot point estimate only
for l = 1:m
    se(l)=sqrt(VYhat(jj,jj,l));
end
if plot_bands ==0
    se = se*0;
    set(gca,'YGrid','on','LineWidth',0.1)
end

%plot(date1(tt),Xdat(jj,tt),'k-',date1(tt1),Yhat(jj,tt1),'r-')
hold on
grpyat   = [date1(tt1) (YYhat(tt1)-ff*se(tt1))' ; date1(ttx) (YYhat(ttx)+ff*se(ttx))'];
patch(grpyat(:,1),grpyat(:,2),[0.9 0.9 0.9],'edgecolor',[0.8 0.8 0.8]);

plot(date1(tt),XXdat(tt),'b-',date1(tt1),YYhat(tt1),'r:','LineWidth',2)
%set(gca,'XTick',date1(tt(1)):1:date1(tt(end)))
%set(gca, 'Xticklabel',date1(tt(1)):1:date1(tt(end)))
%set(gca,'XTickLabel',{'2007','2088','2009'})
set(gca,'Ycolor',[0 0 0.4])
set(gca,'Xcolor',[0 0 0.4])


line(date1(tt1),zeros(size(date1(tt1))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

line('XData',[date1(nT)+0.12, date1(nT)+.12],'YData',[min(0,min(min(YYhat(tt1)-ff*se(tt1), [XXdat(tt) zeros(1,length(tt1)-length(tt))]))), ...
     max(0,max(max(YYhat(tt1)+ff*se(tt1), [XXdat(tt) zeros(1,length(tt1)-length(tt))])))], ...
    'LineStyle','-', 'LineWidth', 2, 'Color',[0.5 0.5 0.5])

hold off

title(str,'Color',[0 0 0.4],'FontName','Gill Sans MT')
axis tight