function [initxi,F,H,Q,RR,rho,D,A,B1,V_eps,initV,l_z,l_psi,is,alf,taum,taub,taus,tausb,alpha,b,beta,pii,Re, ...
    Ra,muzstar,upsil,R] = prepforecast(accuracy, ...
    xx,par,taumat,her,Rb,Re,c,y,invest,mb,w,l,k,n,pii,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
    currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,taushock1,R,ttt2,entr,taushock3, ...
    duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot)

[alphas,alpha_2,alpha_1,alpha_0,betas,D,rho,V_eps,RR,l_psi,l_x,l_eps, ...
    tau,x,gamma,alpha,tauc,taud,beta,b,upsil,ksi,psil,psik,muzstar,Taylor,params,Re,c,y,invest,w,l, ...
    rk,k,n,pii,g,Pe,G,Gp,omegabar,Rk,Gs,sigma,her,Rb,mb,m,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M] = ...
    unld(xx,par,taushock,tauvar,tauvar2,parstoch,Xdat,taushock1,taushock3,size_a,size_b,params, ...
    Re,c,y,invest,w,l,k,n,pii,g,Pe,G,Gp,omegabar,Rk,rk,Gs,her,Rb,mb,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M);

[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);

l_z = length(A);

[H,F,Q,initV,is,alf,taum,taub,taus,tausb,D,B1,B2]  =   kalman_matrices(D,rho,V_eps,A,alphas,betas,taumat, ...
    tau,her,ksi,Rb,Re,c,y,invest,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pii,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,J,ric,M,m1,upsil,currdep,Ra,dm,m3,demean,mm, ...
    parstoch,l_eps,duration1,beta,tauvar,RR,gamma,alpha,R,ttt2,entr,tauc,duration2,taud,params);

if is == 1
    initxi  =   zeros(2*(l_z+l_psi),1);
else
    initxi  =   zeros(2*l_z+l_psi,1);    
end

[alf,taum,taub,taus,tausb] = linear1(tau,her,ksi,Rb,Re,c,y,invest,mb,m,x,psil,w,l,psik,rk, ...
    k,muzstar,n,pii,g,ev,Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,M,m1,upsil,currdep,Ra,dm,m3,l_z,demean,mm, ...
    taushock,parstoch,A,B1,B2,duration1,rho,beta,tauvar,gamma,alpha,R,ttt2,entr,tauc,duration2,taud,params);
