function table_vardec_sample(outfolder,nameshock,namevariable,Corrs,Relvar,name,entr,cdir)

nameshock = nameshock(1:end-1,:); %remove the string in last row which refers to 'Measurement error'
nameshock = char(nameshock,'Total'); %add string 'Total' which refers to sum of relative variances

ncol = size(nameshock,1)+1; %last column is for string with variable names 
lengthxx = size(namevariable,1);

fid=fopen([outfolder '\write_temp_sam.m'],'w');

fprintf(fid,'function write_temp_sam \n');

fprintf(fid,['fid = fopen(''' [strrep(cdir,'\','\\') '\\' outfolder(3:end) '\\' name] ''',''w''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\documentclass{article} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsfonts} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\usepackage{amsmath} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\setcounter{MaxMatrixCols}{10} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{OutputFilter=LATEX.DLL} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Version=4.10.0.2345} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{Created=Thursday, October 31, 2002 05:55:21} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{LastRevised=Thursday, October 31, 2002 06:08:51} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\\\Standard LaTeX Article">} \\n''); \n');
fprintf(fid,'fprintf(fid,'' %%%%TCIDATA{CSTFile=40 LaTeX article.cst} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\newtheorem{theorem}{Theorem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{acknowledgement}[theorem]{Acknowledgement} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{algorithm}[theorem]{Algorithm} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{axiom}[theorem]{Axiom} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{case}[theorem]{Case} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{claim}[theorem]{Claim} \\n''); \n' );
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conclusion}[theorem]{Conclusion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{condition}[theorem]{Condition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{conjecture}[theorem]{Conjecture} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{corollary}[theorem]{Corollary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{criterion}[theorem]{Criterion} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{definition}[theorem]{Definition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{example}[theorem]{Example} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{exercise}[theorem]{Exercise} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{lemma}[theorem]{Lemma} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{notation}[theorem]{Notation} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{problem}[theorem]{Problem} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{proposition}[theorem]{Proposition} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{remark}[theorem]{Remark} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{solution}[theorem]{Solution} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newtheorem{summary}[theorem]{Summary} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\newenvironment{proof}[1][Proof]{\\\\noindent\\\\textbf{#1.} }{\\\\ \\\\rule{0.5em}{0.5em}} \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\input{tcilatex} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{document} \\n''); \n');

fprintf(fid,'fprintf(fid,'' \\\\begin{equation*} \\n''); \n');

nn = '|l||';
for ii=1:ncol-3
    nn = [nn 'c|'];
end
nn= [nn 'c||' 'c|'];
fprintf(fid,['fprintf(fid,'' \\\\begin{tabular}{' nn '} \\\\hline \\n ''); \n']);

fprintf(fid,['fprintf(fid,'' \\\\multicolumn{' num2str(ncol) '}{|c|}{Table: Variance Decomposition Computed in Sample in entr=' num2str(entr) ' Model} \\\\\\\\ [1.5ex] \\\\hline \\n''); \n']);

fprintf(fid,' keyboard  \n');

nameshock_ = ['''$' deblank(nameshock(1,:)) '$'''];
ssf = '{%%s}';
for ii=2:ncol-1
    nameshock_ = [nameshock_ ',''$' deblank(nameshock(ii,:)) '$'''];
    ssf = [ssf '& {%%s}'];
end
ssf = ['multicolumn{1}{|l||}{}& ' ssf];

fprintf(fid,['fprintf(fid, '' \\\\'  ssf ' \\\\\\\\ [1.5ex] \\\\hline \\n'',' nameshock_ '); \n']);


for ii=1:lengthxx
    if abs(Relvar(ii,1)) < 1
        if abs(Relvar(ii,1)) < 0.05
            abc = '0';
        elseif abs(Relvar(ii,1)) >= 0.05 && abs(Relvar(ii,1)) < 0.1
            abc = '0.1';
        else
            abc = num2str(Relvar(ii,1),1);
        end
    else
        abc = num2str(Relvar(ii,1),2);
    end
    if abs(Corrs(ii,1)) < 0.05
        abcd = '0';
    elseif abs(Corrs(ii,1)) >= 0.05 && abs(Corrs(ii,1)) < 0.1
        if sign(Corrs(ii,1)) < 0
            abcd = '-0.1';
        else        
            abcd = '0.1';
        end
    else
        abcd = num2str(Corrs(ii,1),1);
    end

    rowii = [abc '|' abcd];
    for jj=2:ncol-2
        if abs(Relvar(ii,jj)) < 1
            if abs(Relvar(ii,jj)) < 0.05
                abc = '0';
            elseif abs(Relvar(ii,jj)) >= 0.05 && abs(Relvar(ii,jj)) < 0.1
                abc = '0.1';
            else
                abc = num2str(Relvar(ii,jj),1);
            end
        else
            abc = num2str(Relvar(ii,jj),2);
        end

        if abs(Corrs(ii,jj)) < 0.05
            abcd = '0';
        elseif abs(Corrs(ii,jj)) >= 0.05 && abs(Corrs(ii,jj)) < 0.1
            if sign(Corrs(ii,jj)) < 0
                abcd = '-0.1';
            else
                abcd = '0.1';
            end
        else
            abcd = num2str(Corrs(ii,jj),1);
        end

        rowii = [rowii ' & ' abc '|' abcd];
    end
    rowii = ['multicolumn{1}{|l||}{' namevariable(ii,1:11) '} & ' rowii '& ' num2str(sum(Relvar(ii,:)),2)];
    fprintf(fid,['fprintf(fid,'' \\\\' rowii   ' \\\\\\\\  \\\\hline \\n''); \n']);
end


fprintf(fid,'fprintf(fid,'' \\\\end{tabular}%%%% \\n''); \n');
fprintf(fid,'fprintf(fid,'' \\\\end{equation*}%%%% \\n''); \n');

fprintf(fid,['fprintf(fid,'' {\\\\small Note: }{\\\\small The first element of each column refers to the in-sample relative variance computed as var(y(i))/var(y), where var(y(i)) is the variance of variable y under the counterfactual simulation that all estimated shocks, with the exception of shock i, are set to zero, and var(y) is the variance of the two-sided fitted variable y. The second element of each column refers to the correlation, corr(y,y(i)). The last column displays the sum of the relative variances.}\\n''); \n']);

fprintf(fid,'fprintf(fid,'' \\\\end{document} \\n''); \n');
fprintf(fid,'fclose(fid);');

fclose(fid);

addpath([cdir outfolder(2:end)])
write_temp_sam
rmpath([cdir outfolder(2:end)])
